//--------------------------------------------------------------------//
// tN^ (}fuWEWAWEj[gAgN^)

var canvas;				// LoXvf
var context;	 			// ReLXg
var image;				// `p摜
var pixel;				// 摜sNZf[^
var width,height;			// f[^̈敝E
var pressed;				// }EX{^
var mx,my;				// }EXʒu
var direc;				// \
var frac;				// tN^֐
var iterMax;				// vZ񐔂̏
var angleCoef;				// pxW
var fracFunc,colorFunc;			// tN^EJ[o[̊֐

// J[o[֐
var COLORS=[colorBar1,colorBar2,colorBar3,colorBar4];
var INIT_TOLERANCE=1.0e-8;		// e덷
var MAX_MAGNITUDE=4;			// vZI̔l
var POINTER_SIZE=4;			// |C^̕`TCY
var COLOR_ITER=8;			// JԂJ[o[̌JԂ

// tN^
function initFractal(iter){
  iterMax=100;
  if(iter!==undefined) iterMax=iter;
  angleCoef=iterMax/(2*Math.PI);
  initCanvas();
  draw();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('fractal');
  width=canvas.clientWidth;
  height=canvas.clientHeight;
  canvas.width=width;
  canvas.height=height;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  context=canvas.getContext('2d');
  image=context.createImageData(width,height);
  pixel=image.data;
  var size=4*width*height;
  for(var i=3;i<size;i+=4) pixel[i]=255;	// l255Œ
  frac=new Fractal();
  document.getElementById('fracfunc').selectedIndex=0;
  document.getElementById('color').selectedIndex=0;
  fracFunc=mandelbrot2;
  colorFunc=COLORS[0];
  direc=1;
  pressed=false;
  mx=0;
  my=0;
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  var rect=e.target.getBoundingClientRect();
  mx=parseInt(e.clientX-rect.left);
  my=parseInt(e.clientY-rect.top);
  drawPointer(mx,my);
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
  var rect=e.target.getBoundingClientRect();
  var mx2=parseInt(e.clientX-rect.left);
  var my2=parseInt(e.clientY-rect.top);
  zoom(mx,my,mx2,my2);
  mx=0;
  my=0;
}

// tN^֐̌vZ
function calcFractalImage(){
  var ii=0,coef=direc*frac.coefxy;
  var xb=frac.x-0.5*direc*frac.dWidth;
  var yb=frac.y+0.5*direc*frac.dHeight;
  for(var j=0;j<height;j++){
    var y1=yb-coef*j;
    for(var i=0;i<width;i++){
      var x1=xb+coef*i;
      var z=fracFunc(frac.alpha,frac.beta,x1,y1);
      colorFunc(pixel,ii,z);
      ii+=4;
    }
  }
}

// `悷
function draw(){
  calcFractalImage();
  context.putImageData(image,0,0);
}

// |C^`悷
// x,y - |C^W
function drawPointer(x,y){
  for(var i=-POINTER_SIZE;i<=POINTER_SIZE;i++){
    var idx1=4*(width*y+x+i);
    var idx2=4*(width*(y+i)+x);
    for(var j=0;j<3;j++){
      pixel[idx1+j]=255;
      pixel[idx2+j]=255;
    }
  }
  context.putImageData(image,0,0);
}

// g`悷
// x1,y1 - 1_̍W
// x2,y2 - 2_̍W
function zoom(x1,y1,x2,y2){
  if(direc<0){
    frac.setRegion(width-x1,height-y1,width-x2,height-y2);
  }
  else{
    frac.setRegion(x1,y1,x2,y2);
  }
  draw();
}

// p[^ݒ肷
function setParameters(){
  var re=Number(document.getElementById('real').value);
  var im=Number(document.getElementById('imag').value);
  document.getElementById('reval').textContent=re.toFixed(2);
  document.getElementById('imval').textContent=im.toFixed(2);
  frac.setParameter(re,im);
  draw();
}

// tN^֐؂ւ
function setFractal(){
  var f=document.getElementById('fracfunc').value;
  switch(f){
    case 'm2':
      fracFunc=mandelbrot2;
      break;
    case 'j2':
      fracFunc=julia2;
      break;
    case 'b2':
      fracFunc=burningShip2;
      break;
    case 't2':
      fracFunc=tricorn2;
      break;
    case 'n2':
      fracFunc=newton2;
      break;
    case 'm3':
      fracFunc=mandelbrot3;
      break;
    case 'j3':
      fracFunc=julia3;
      break;
    case 'b3':
      fracFunc=burningShip3;
      break;
    case 't3':
      fracFunc=tricorn3;
      break;
    case 'n3':
      fracFunc=newton3;
      break;
    case 'm4':
      fracFunc=mandelbrot4;
      break;
    case 'j4':
      fracFunc=julia4;
      break;
    case 'b4':
      fracFunc=burningShip4;
      break;
    case 't4':
      fracFunc=tricorn4;
      break;
    case 'n4':
      fracFunc=newton4;
      break;
    case 'm5':
      fracFunc=mandelbrot5;
      break;
    case 'j5':
      fracFunc=julia5;
      break;
    case 'b5':
      fracFunc=burningShip5;
      break;
    case 't5':
      fracFunc=tricorn5;
      break;
    case 'n5':
      fracFunc=newton5;
      break;
  }
  frac.init();
  draw();
}

// J[o[؂ւ
function setColor(){
  var c=document.getElementById('color').selectedIndex;
  colorFunc=COLORS[c];
  draw();
}

// \Zbg
function viewReset(){
  frac.init();
  draw();
}

// \𔽓]
function viewReverse(){
  direc=-direc;
  viewReset();
}

// 2}fuW zk = zk-1^2 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function mandelbrot2(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z12=z1*z2;
    z1=z11-z22+c1;
    z2=z12+z12+c2;
  }
  return 1;
}

// 3}fuW zk = zk-1^3 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function mandelbrot3(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    z1=z1*(z11-3*z22)+c1;
    z2=z2*(3*z11-z22)+c2;
  }
  return 1;
}

// 4}fuW zk = zk-1^4 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function mandelbrot4(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z212=2*z1*z2;
    z1=(z11-z22+z212)*(z11-z22-z212)+c1;
    z2=2*z212*(z11-z22)+c2;
  }
  return 1;
}

// 5}fuW zk = zk-1^5 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function mandelbrot5(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z412=4*z11*z22;
    z1=z1*((z11-z22)*(z11-5*z22)-z412)+c1;
    z2=z2*((z11-z22)*(5*z11-z22)-z412)+c2;
  }
  return 1;
}

// 2WAW zk = zk-1^2 + c ̔񐔔䗦Ԃ
// c1,c2 - c̏l̎C
// z1,z2 - z̏l̎C
function julia2(c1,c2,z1,z2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z12=z1*z2;
    z1=z11-z22+c1;
    z2=z12+z12+c2;
  }
  return 1;
}

// 3WAW zk = zk-1^3 + c ̔񐔔䗦Ԃ
// c1,c2 - c̏l̎C
// z1,z2 - z̏l̎C
function julia3(c1,c2,z1,z2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    z1=z1*(z11-3*z22)+c1;
    z2=z2*(3*z11-z22)+c2;
  }
  return 1;
}

// 4WAW zk = zk-1^4 + c ̔񐔔䗦Ԃ
// c1,c2 - c̏l̎C
// z1,z2 - z̏l̎C
function julia4(c1,c2,z1,z2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z212=2*z1*z2;
    z1=(z11-z22+z212)*(z11-z22-z212)+c1;
    z2=2*z212*(z11-z22)+c2;
  }
  return 1;
}

// 5WAW zk = zk-1^5 + c ̔񐔔䗦Ԃ
// c1,c2 - c̏l̎C
// z1,z2 - z̏l̎C
function julia5(c1,c2,z1,z2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z412=4*z11*z22;
    z1=z1*((z11-z22)*(z11-5*z22)-z412)+c1;
    z2=z2*((z11-z22)*(5*z11-z22)-z412)+c2;
  }
  return 1;
}

// 2o[jOVbv zk = (|Rezk-1|+i|Imzk-1|)^2 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function burningShip2(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z12=z1*z2;
    z1=z11-z22+c1;
    z2=Math.abs(z12+z12)+c2;
  }
  return 1;
}

// 3o[jOVbv zk = (|Rezk-1|+i|Imzk-1|)^3 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function burningShip3(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    z1=Math.abs(z1)*(z11-3*z22)+c1;
    z2=Math.abs(z2)*(3*z11-z22)+c2;
  }
  return 1;
}

// 4o[jOVbv zk = (|Rezk-1|+i|Imzk-1|)^4 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function burningShip4(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z212=2*Math.abs(z1*z2);
    z1=(z11-z22+z212)*(z11-z22-z212)+c1;
    z2=2*z212*(z11-z22)+c2;
  }
  return 1;
}

// 5o[jOVbv zk = (|Rezk-1|+i|Imzk-1|)^5 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function burningShip5(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z412=4*z11*z22;
    z1=Math.abs(z1)*((z11-z22)*(z11-5*z22)-z412)+c1;
    z2=Math.abs(z2)*((z11-z22)*(5*z11-z22)-z412)+c2;
  }
  return 1;
}

// 2gCR[ zk = conj(zk-1)^2 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function tricorn2(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z12=-z1*z2;
    z1=z11-z22+c1;
    z2=z12+z12+c2;
  }
  return 1;
}

// 3gCR[ zk = conj(zk-1)^3 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function tricorn3(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    z1=z1*(z11-3*z22)+c1;
    z2=-z2*(3*z11-z22)+c2;
  }
  return 1;
}

// 4gCR[ zk = conj(zk-1)^4 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function tricorn4(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z212=2*z1*z2;
    z1=(z11-z22+z212)*(z11-z22-z212)+c1;
    z2=-2*z212*(z11-z22)+c2;
  }
  return 1;
}

// 5gCR[ zk = conj(zk-1)^5 + c ̔񐔔䗦Ԃ
// z1,z2 - z̏l̎C
// c1,c2 - c̏l̎C
function tricorn5(z1,z2,c1,c2){
  for(var i=0;i<iterMax;i++){
    var z11=z1*z1;
    var z22=z2*z2;
    var mag=z11+z22;
    if(mag>MAX_MAGNITUDE) return i/iterMax;
    var z412=4*z11*z22;
    z1=z1*((z11-z22)*(z11-5*z22)-z412)+c1;
    z2=-z2*((z11-z22)*(5*z11-z22)-z412)+c2;
  }
  return 1;
}

// 2j[gAgN^ z^2 = 1 ̎̕fʏł̈ʑpԂ
// c1,c2 - c̏l̎Ci_~[j
// z1,z2 - z̏l̎C
function newton2(c1,c2,z1,z2){
  if((z1===0) && (z2===0)) return 0;
  var k=0,mag2;
  do{
    var mag=0.5/(z1*z1+z2*z2);
    var xn=z1*(0.5+mag);
    var yn=z2*(0.5-mag);
    mag2=(xn-z1)*(xn-z1)+(yn-z2)*(yn-z2);
    z1=xn;
    z2=yn;
    k++;
  }while((k<iterMax) && (mag2>frac.tolerance));
  var angle=Math.round(angleCoef*Math.atan2(z2,z1))/iterMax;
  while(angle<0) angle+=1;
  return angle;
}

// 3j[gAgN^ z^3 = 1 ̎̕fʏł̈ʑpԂ
// c1,c2 - c̏l̎Ci_~[j
// z1,z2 - z̏l̎C
function newton3(c1,c2,z1,z2){
  if((z1===0) && (z2===0)) return 0;
  var k=0,mag2;
  do{
    var zr=z1*z1-z2*z2;
    var zi=2.0*z1*z2;
    var mag=1/(3*(zr*zr+zi*zi));
    var xn=2*z1/3+mag*zr;
    var yn=2*z2/3-mag*zi;
    mag2=(xn-z1)*(xn-z1)+(yn-z2)*(yn-z2);
    z1=xn;
    z2=yn;
    k++;
  }while((k<iterMax) && (mag2>frac.tolerance));
  var angle=Math.round(angleCoef*Math.atan2(z2,z1))/iterMax;
  while(angle<0) angle+=1;
  return angle;
}

// 4j[gAgN^ z^4 = 1 ̎̕fʏł̈ʑpԂ
// c1,c2 - c̏l̎Ci_~[j
// z1,z2 - z̏l̎C
function newton4(c1,c2,z1,z2){
  if((z1===0) && (z2===0)) return 0;
  var k=0,mag2;
  do{
    var z12=z1*z1;
    var z22=z2*z2;
    var zr=z1*(z12-3*z22);
    var zi=z2*(3*z12-z22);
    var mag=0.25/(zr*zr+zi*zi);
    var xn=0.75*z1+mag*zr;
    var yn=0.75*z2-mag*zi;
    mag2=(xn-z1)*(xn-z1)+(yn-z2)*(yn-z2);
    z1=xn;
    z2=yn;
    k++;
  }while((k<iterMax) && (mag2>frac.tolerance));
  var angle=Math.round(angleCoef*Math.atan2(z2,z1))/iterMax;
  while(angle<0) angle+=1;
  return angle;
}

// 5j[gAgN^ z^5 = 1 ̎̕fʏł̈ʑpԂ
// c1,c2 - c̏l̎Ci_~[j
// z1,z2 - z̏l̎C
function newton5(c1,c2,z1,z2){
  if((z1===0) && (z2===0)) return 0;
  var k=0,mag2;
  do{
    var z12=z1*z1;
    var z22=z2*z2;
    var z1z2=2*z1*z2;
    var zr=(z12-z22+z1z2)*(z12-z22-z1z2);
    var zi=2*z1z2*(z12-z22);
    var mag=0.2/(zr*zr+zi*zi);
    var xn=0.8*z1+mag*zr;
    var yn=0.8*z2-mag*zi;
    mag2=(xn-z1)*(xn-z1)+(yn-z2)*(yn-z2);
    z1=xn;
    z2=yn;
    k++;
  }while((k<iterMax) && (mag2>frac.tolerance));
  var angle=Math.round(angleCoef*Math.atan2(z2,z1))/iterMax;
  while(angle<0) angle+=1;
  return angle;
}

// J[o[1iWJ[o[jݒ肷
// pixel - rbg}bvf[^
// index - f[^JnCfbNX
// z - f[^i0`1j
function colorBar1(pixel,index,z){
  z*=4;
  if(z<=0){
    pixel[index]=0;
    pixel[index+1]=0;
    pixel[index+2]=255;
  }
  else if(z<1){
    pixel[index]=0;
    pixel[index+1]=parseInt(255*z);
    pixel[index+2]=255;
  }
  else if(z<2){
    pixel[index]=0;
    pixel[index+1]=225+parseInt(30*(2-z));
    pixel[index+2]=parseInt(255*(2-z));
  }
  else if(z<3){
    pixel[index]=parseInt(255*(z-2));
    pixel[index+1]=225+parseInt(30*(z-2));
    pixel[index+2]=0;
  }
  else if(z<4){
    pixel[index]=255;
    pixel[index+1]=parseInt(255*(4-z));
    pixel[index+2]=0;
  }
  else{
    pixel[index]=0;
    pixel[index+1]=0;
    pixel[index+2]=0;
  }
}

// J[o[2iFJ[o[jݒ肷
// pixel - rbg}bvf[^
// index - f[^JnCfbNX
// z - f[^i0`1j
function colorBar2(pixel,index,z){
  if(z<1){
    pixel[index]=255*z;
    pixel[index+1]=pixel[index];
    pixel[index+2]=102+153*z;
  }
  else{
    pixel[index]=0;
    pixel[index+1]=0;
    pixel[index+2]=0;
  }
}

// J[o[3iԐFJ[o[jݒ肷
// pixel - rbg}bvf[^
// index - f[^JnCfbNX
// z - f[^i0`1j
function colorBar3(pixel,index,z){
  if(z<1){
    pixel[index]=255;
    pixel[index+1]=255*z;
    pixel[index+2]=255*z;
  }
  else{
    pixel[index]=0;
    pixel[index+1]=0;
    pixel[index+2]=0;
  }
}

// J[o[4iJԂJ[o[jݒ肷
// pixel - rbg}bvf[^
// index - f[^JnCfbNX
// z - f[^i0`1j
function colorBar4(pixel,index,z){
  if(z>=1){
    pixel[index]=0;
    pixel[index+1]=0;
    pixel[index+2]=0;
    return;
  }
  z=6*(COLOR_ITER*z-parseInt(COLOR_ITER*z));
  if(z<1){
    pixel[index]=0;
    pixel[index+1]=parseInt(255*z);
    pixel[index+2]=255;
  }
  else if(z<2){
    pixel[index]=0;
    pixel[index+1]=255;
    pixel[index+2]=parseInt(255*(2-z));
  }
  else if(z<3){
    pixel[index]=parseInt(255*(z-2));
    pixel[index+1]=255;
    pixel[index+2]=0;
  }
  else if(z<4){
    pixel[index]=255;
    pixel[index+1]=parseInt(255*(4-z));
    pixel[index+2]=0;
  }
  else if(z<5){
    pixel[index]=255;
    pixel[index+1]=0;
    pixel[index+2]=parseInt(255*(z-4));
  }
  else{
    pixel[index]=parseInt(255*(6-z));
    pixel[index+1]=0;
    pixel[index+2]=255;
  }
}

//--------------------------------------------------------------------//
// tN^֐
var Fractal=function(){
  this.alpha=0;				// 萔p[^̎
  this.beta=0;				// 萔p[^̋
  this.init();
};

// 
Fractal.prototype.init=function(){
  this.x=0;				// `_W
  this.y=0;
  this.coefxy=4/Math.min(width,height);	// WϊW
  this.dWidth=this.coefxy*width;	// \̈TCY
  this.dHeight=this.coefxy*height;	// \̈TCY
  this.tolerance=INIT_TOLERANCE;	// e덷
};

// 萔p[^ݒ肷
// alpha,beta - 萔p[^̎C
Fractal.prototype.setParameter=function(alpha,beta){
  this.alpha=alpha;
  this.beta=beta;
};

// `̈ݒ肷
// x1,y1 - 1_̍W
// x2,y2 - 2_̍W
Fractal.prototype.setRegion=function(x1,y1,x2,y2){
  this.x-=0.5*(this.dWidth-this.coefxy*(x1+x2));
  this.y+=0.5*(this.dHeight-this.coefxy*(y1+y2));
  var coefd=Math.max(Math.abs(x1-x2)/width,Math.abs(y1-y2)/height);
  if(coefd===0) coefd=1/Math.max(width,height);
  this.dWidth*=coefd;
  this.dHeight*=coefd;
  this.coefxy*=coefd;
  this.tolerance*=coefd;
};
